// Extreme.cc

#include <cmath>
#include <iostream>

#include <cstdlib>

#include <cstdio>

#include "Extreme.h"
#include "Voronoi.h"
#include "la_support.h"

void die_extreme(const char* last_words)
{
  std::cout <<"Extreme.cc: " <<last_words;
  exit(EXIT_FAILURE);
}

/*int gcd(int a, int b)
{
  if (a < b)
    return gcd(b,a);
  else {
    int r = a % b;
    if (r == 0) 
      return b;
    else 
      return gcd(b,r);
  }
}*/

Extreme::Extreme(double* in)
{
  int i,j;

  doubleMakeVector(Dim, &q);
  doubleCopyVector(Dim, in, q);

  double** mat;
  doubleMakeSquareMatrix(dim,&mat);

  for(i=0;i<dim;i++)
	for(j=0;j<dim;j++){
		if(i<j){
			mat[i][j]=q[j*(j+1)/2+i];
		}
		else{
			mat[i][j]=q[i*(i+1)/2+j];
		}
  }
		
  rank=doubleMatrixRank(dim,mat);

  doubleDestroySquareMatrix(dim,&mat);
}


Extreme::Extreme(const Extreme& E)
{
  doubleMakeVector(Dim, &q);
  doubleCopyVector(Dim, E.q, q);
  rank=E.rank;
}

Extreme::~Extreme()
{
  doubleDestroyVector(Dim, &q);
}

Extreme& Extreme::operator=(const Extreme& E)
{
  if (this != &E) {
    doubleCopyVector(Dim, E.q, q);
    rank=E.rank;
  }
  return *this;
}

bool Extreme::operator==(const Extreme& E) const
{
  if (rank!=E.rank) 
	return false;
  return !(*this < E) && !(E < *this);
}

bool Extreme::operator<(const Extreme& E) const
{
  for (int i = 0; i < Dim; i++) {
    double sign = q[i] - E.q[i];
    if (sign < -0.5) return true;
    if (sign > 0.5) return false;
  }
  return false;
}

int Extreme::give_rank()
{
  return rank;
}
